
Imports System
Imports System.Runtime.InteropServices
Imports System.Resources
Imports System.IO

Namespace myWav

    Public Class WinWav
        'Declare constants 
        Public Const SND_ASYNC As Int32 = 1
        Public Const SND_MEMORY As Int32 = 4

        'this is the overload we want to play embedded Wav resource... 
        Public Declare Function PlaySound Lib "winmm.dll" Alias "PlaySound" (ByVal data() As Byte, ByVal hMod As IntPtr, ByVal dwFlags As Int32) As Boolean

        Public Shared Function PlayWavResource(ByVal wav As String)
            'BE SURE loveplan.wav HAS BUILD ACTION IN PROPERTIES SET TO EMBEDDED RESOURCE
            'get the namespace 
            Dim strNameSpace As String = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name.ToString()
            ' get the resource into a stream 
            Dim Str As Stream = System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream(strNameSpace + "." + wav)
            'MsgBox(strNameSpace + "." + wav)

            If Str Is Nothing Then
                MsgBox("No Stream From: " & wav)
                Exit Function
            End If
            If Str.CanRead Then
                'bring stream into a byte array 
                Dim bStr(Str.Length) As Byte
                'bStr = New Byte(Str.Length) {}
                Str.Read(bStr, 0, Int(Str.Length))
                'play the resource 
                PlaySound(bStr, IntPtr.Zero, SND_ASYNC Or SND_MEMORY)
            End If
        End Function

    End Class

End Namespace